-----------------------------------------------------
-- Scannex Electronics Limited
-- 2008-09-02
-- Matt Page
--
-- Script to count the number of times a caller rings
-----------------------------------------------------

caller_limit = 40
callers = {}
alert.register_oneshot("CallerLimit", "", 10*60)  --Don't email repeats within 10min
--alert.register_trap("CallerLimit", 10001)       --Assign a specific trap number as well

function check_number(caller)
 local day=string.sub(i.now, 1, 10)
 if day ~= last_day
 then  --Reset the counts if the day is different
  callers = {}
  last_day = day
 end

 if not callers[caller]
 then callers[caller] = 1
 else 
  callers[caller] = callers[caller] + 1
  if callers[caller] > caller_limit
  then
   alert.alarm("CallerLimit", caller)                --Send out the email alert
   -- mem.write(1,"!! Call Limit: "..caller.."\r\n")  --Write to the memory store as well
  end
 end
end




-----------------------------------------------------
-- NEC NEAX specific code here...
-----------------------------------------------------
function neax_data(txt, chnl, tag)
 mem.write(chnl, txt)                          --Write to the channel storage first
 local call_type = string.sub(txt, 4, 4)       --Pull out the call type letter
 local caller = string.match(txt, "%d+", 98)   --Pull out the caller number
 if (call_type=="E") and caller                --Only incoming calls with a telephone number
 then
  check_number(caller)
 end
end

x.chnl[1].src.onrecord = neax_data             --Bind the event

